      subroutine apptemp(FFT, IDIM1, IDIM2, PIXSIZE, TEMPFAC)

C     apply tempfactor to the 2D FFT
      
      implicit none
      
      integer, intent(in) :: idim1, idim2
      real, intent(in)    :: pixsize, tempfac
      real, intent(inout) :: fft(0:idim1, -idim2:idim2)

      integer ix, iy, idm
      real    x, y, tmp, d_star, t, xsq

      idm = IDIM1*2+1

      tmp = 10.0/(idm*pixsize) ! Convert to nm units
      do ix = -idim2, idim2
         x = real(ix)
         xsq = x*x
         do iy = 0, idim1
            y = real(iy)
            d_star = sqrt(y*y + xsq) * tmp
            t = exp((tempfac/400.0) * (d_star*d_star)) ! Adjusted for nm
            fft(iy,ix) = fft(iy,ix) * t
         enddo
      enddo

      return
      end subroutine apptemp
